package
{
    import flash.display.DisplayObjectContainer;
    
    import jf.directory.controllers.commands.InitializeCommand;
    import jf.directory.controllers.commands.CreateSiteCommand;
    import jf.directory.controllers.commands.CreateTagCommand;
    import jf.directory.controllers.commands.LoadCategoryCommand;
    import jf.directory.controllers.commands.LoadSiteCommand;
    import jf.directory.controllers.commands.LoadTagCommand;
    import jf.directory.controllers.commands.StartupCommand;
    import jf.directory.controllers.events.CreateSiteEvent;
    import jf.directory.controllers.events.CreateTagEvent;
    import jf.directory.controllers.events.DirectoryEvent;
    import jf.directory.controllers.events.LoadCategoryEvent;
    import jf.directory.controllers.events.LoadSiteEvent;
    import jf.directory.controllers.events.LoadTagEvent;
    import jf.directory.models.CategoryModel;
    import jf.directory.models.SiteModel;
    import jf.directory.models.TagModel;
    import jf.directory.models.XMLServiceProxy;
    import jf.directory.models.services.IDirectoryService;
    import jf.directory.models.services.RemoteDirectoryService;
    import jf.directory.views.components.DirectoryView;
    import jf.directory.views.components.SubscribeView;
    import jf.directory.views.components.TagSelection;
    import jf.directory.views.mediators.DirectoryMediator;
    import jf.directory.views.mediators.SubscribeMediator;
    import jf.directory.views.mediators.TagSelectionMediator;
    
    import org.robotlegs.mvcs.Context;
    
    public class MainContext extends Context
    {
        public function MainContext(contextView:DisplayObjectContainer=null, autoStartup:Boolean=true)
        {
            super(contextView, autoStartup);
        }
        
        override public function startup():void
        {
            //Services
            injector.mapSingletonOf(IDirectoryService, RemoteDirectoryService);
            
            //Models
            injector.mapSingleton(XMLServiceProxy);
            injector.mapSingleton(CategoryModel);
            injector.mapSingleton(TagModel);
            injector.mapSingleton(SiteModel);
            
            // Controllers
            commandMap.mapEvent(DirectoryEvent.STARTUP, StartupCommand, DirectoryEvent);
            commandMap.mapEvent(DirectoryEvent.INITALIZE, InitializeCommand, DirectoryEvent);
            commandMap.mapEvent(LoadSiteEvent.LOAD_SITE, LoadSiteCommand, LoadSiteEvent);
            commandMap.mapEvent(LoadCategoryEvent.LOAD_CATEGORY, LoadCategoryCommand, LoadCategoryEvent);
            commandMap.mapEvent(LoadTagEvent.LOAD_TAG, LoadTagCommand, LoadTagEvent);
            commandMap.mapEvent(CreateSiteEvent.CREATE_SITE, CreateSiteCommand, CreateSiteEvent);
            commandMap.mapEvent(CreateTagEvent.CREATE_TAG, CreateTagCommand, CreateTagEvent);

            //Views
            mediatorMap.mapView(Main, MainMediator);
            mediatorMap.mapView(TagSelection, TagSelectionMediator);
            
            mediatorMap.mapView(DirectoryView, DirectoryMediator);
            mediatorMap.mapView(SubscribeView, SubscribeMediator);
        }
    }
}