package jf.directory.controllers.commands
{
    import jf.directory.controllers.events.LoadCategoryEvent;
    import jf.directory.models.XMLServiceProxy;
    import jf.directory.models.services.IDirectoryService;
    import jf.directory.models.services.RemoteDirectoryService;
    import jf.directory.models.services.RemoteService;
    
    import org.robotlegs.mvcs.Command;
    
    public class InitializeCommand extends Command
    {
        [Inject]
        public var xmlServiceProxy:XMLServiceProxy;
        
        [Inject]
        public var directoryService:IDirectoryService;
        
        override public function execute() : void
        {
            if(directoryService is RemoteService)
            {
                initializeRemoteService(directoryService as RemoteService, "directory");
            }
            
            run();
        }
        
        protected function initializeRemoteService(remoteService:RemoteService, id:String):void
        {
            var config:XMLList = xmlServiceProxy.getRemoteConfiguration(id);
            
            if(config)
            {
                remoteService.remoteObject.destination = config.destination;
                remoteService.remoteObject.source = config.source;
                remoteService.remoteObject.endpoint = config.endpoint;
            }
        }
        
        protected function run():void
        {
            dispatch(new LoadCategoryEvent(LoadCategoryEvent.LOAD_CATEGORY));
        }
    }
}