package jf.directory.models
{
    import jf.directory.models.events.CategoryModelEvent;
    import jf.directory.models.vo.CategoryVO;
    
    import org.robotlegs.mvcs.Actor;
    
    public class CategoryModel extends Actor
    {
        private var _categories:Vector.<CategoryVO> = new Vector.<CategoryVO>;
        
        private var _hierarchicalCategories:Vector.<CategoryVO> = new Vector.<CategoryVO>;
        
        public function updateCollection(collection:Array):void
        {
            _categories.splice(0, _categories.length);
            
            for each (var category:Object in collection) 
            { 
                _categories.push(category as CategoryVO);
            } 
            
            hierarchy();
            
            dispatch(new CategoryModelEvent(CategoryModelEvent.CATEGORY_COLLECTION, collection));
        }
        
        protected function hierarchy():void
        {
            _hierarchicalCategories.splice(0, _hierarchicalCategories.length);
            
            for each(var category:Object in _categories)
            {
                if(category.categoryId == 0)
                {
                    _hierarchicalCategories.push(category as CategoryVO);
                }
                else
                {
                    var categoryParent:Object = getCategoryParent(category.categoryId);
                    
                    if(categoryParent)
                    {
                        if(categoryParent.children == null)
                        {
                            categoryParent.children = new Array();
                        }
                        
                        categoryParent.children.push(category);
                    }
                }
            }
            
            var collection:Array = new Array();
            
            for each (category in _hierarchicalCategories) 
            { 
                collection.push(category);
            } 
            
            dispatch(new CategoryModelEvent(CategoryModelEvent.CATEGORY_HIERARCHICAL_COLLECTION, collection));
        }
        
        protected function getCategoryParent(id:int):Object
        {
            var categoryParent:Object;
            
            for each(var category:Object in _categories)
            {
                if(category.id == id)
                {
                    categoryParent = category;
                    break;
                }
            }
            
            return categoryParent;
        }
    }
}