package jf.directory.models
{
    import flash.events.Event;
    import flash.events.IOErrorEvent;
    import flash.net.URLLoader;
    import flash.net.URLRequest;
    import flash.utils.Dictionary;
    
    import jf.directory.models.events.XMLServiceProxyEvent;
    
    import org.robotlegs.mvcs.Actor;
    
    public class XMLServiceProxy extends Actor
    {
        private var _xml:XML;
        
        public function load(url:String):void
        {
            var urlLoader:URLLoader = new URLLoader();
            urlLoader.addEventListener(Event.COMPLETE, completeHandler);
            urlLoader.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
            
            urlLoader.load(new URLRequest(url));
        }
        
        public function getRemoteConfiguration(id:String):XMLList
        {
            return _xml.service.(@id == id).length() > 0 ? _xml.service.(@id == id).remote : null;
        }
        
        protected function completeHandler(event:Event):void
        {
            _xml = new XML(URLLoader(event.target).data);
            
            dispatch(new XMLServiceProxyEvent(XMLServiceProxyEvent.XML_SERVICE_COMPLETED));
        }
        
        protected function ioErrorHandler(event:IOErrorEvent):void
        {
            dispatch(new XMLServiceProxyEvent(XMLServiceProxyEvent.ERROR_XML_SERVICE));
        }
    }
}