package jf.directory.views.mediators
{
    import flash.events.MouseEvent;
    
    import jf.directory.controllers.events.CreateSiteEvent;
    import jf.directory.models.events.CategoryModelEvent;
    import jf.directory.models.events.SiteModelEvent;
    import jf.directory.views.components.SubscribeView;
    
    import mx.collections.ArrayCollection;
    
    import org.robotlegs.mvcs.Mediator;
    
    public class SubscribeMediator extends Mediator
    {
        [Inject]
        public var view:SubscribeView;
        
        override public function onRegister():void
        {
            //view
            eventMap.mapListener(view.subscribeBtn, MouseEvent.CLICK, subscribeBtn_clickHandler);
            //eventDispatcher
            eventMap.mapListener(eventDispatcher, CategoryModelEvent.CATEGORY_COLLECTION , categoryCollectionHandler);
            eventMap.mapListener(eventDispatcher, SiteModelEvent.SITE_CREATED , siteCreatedHandler);
        }
        
        protected function subscribeBtn_clickHandler(event:MouseEvent):void
        {
            if(view.validate())
            {
                dispatch(new CreateSiteEvent(CreateSiteEvent.CREATE_SITE, view.siteName, view.siteAddress,
                                             view.siteDescription, view.siteCategoryId, view.siteTagsId));
            }
        }
        
        protected function categoryCollectionHandler(event:CategoryModelEvent):void
        {
            view.categoryProvider = new ArrayCollection(event.collection);
        }
        
        protected function siteCreatedHandler(event:SiteModelEvent):void
        {
            view.showInfo("Votre site à été correctement ajouté à l'annuaire.");
            
            view.reset();
        }
    }
}