package jf.directory.views.mediators
{
    import jf.directory.controllers.events.CreateTagEvent;
    import jf.directory.controllers.events.LoadTagEvent;
    import jf.directory.models.events.TagModelEvent;
    import jf.directory.views.components.TagSelection;
    
    import mx.collections.ArrayCollection;
    import mx.events.FlexEvent;
    
    import org.robotlegs.mvcs.Mediator;
    
    import spark.events.TextOperationEvent;
    
    public class TagSelectionMediator extends Mediator
    {
        [Inject]
        public var component:TagSelection;

        override public function onRegister():void
        {
            //component
            eventMap.mapListener(component.autocomplete, FlexEvent.ENTER, autocomplete_enterHandler);
            eventMap.mapListener(component.autocomplete, TextOperationEvent.CHANGE, autocomplete_changeHandler);
            //eventDispatcher
            eventMap.mapListener(eventDispatcher, TagModelEvent.TAG_COLLECTION, tagCollectionHandler);
            eventMap.mapListener(eventDispatcher, TagModelEvent.TAG_CREATED, tagCreatedHandler);
        }
        
        protected function validate():Boolean
        {
            return component.tagLenght >= component.minTagLenght && component.tagLenght <= component.maxTagLenght ? true : false;
        }
        
        protected function autocomplete_enterHandler(event:FlexEvent):void
        {
            if(component.editable && validate())
            {
                dispatch(new CreateTagEvent(CreateTagEvent.CREATE_TAG, component.tag));
            }
        }
        
        protected function autocomplete_changeHandler(event:TextOperationEvent):void
        {
            if(validate())
            {
                dispatch(new LoadTagEvent(LoadTagEvent.LOAD_TAG, component.tag ));
            }
        }
        
        protected function tagCollectionHandler(event:TagModelEvent):void
        {
            component.dataProvider = new ArrayCollection(event.collection);
        }
        
        protected function tagCreatedHandler(event:TagModelEvent):void
        {
            dispatch(new LoadTagEvent(LoadTagEvent.LOAD_TAG, component.tag ));
        }
    }
}